<?php

header("Content-type: application/json");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

try {
    $req = new REQUEST();
    switch ($req->props['module']) {
     case "graph":
	if ($req->CheckData()) {

	    $req = $req->CreateDataRequest();

	    $draw = $req->CreatePlotter();
	    $draw->Create();
	    $file = $draw->Save();
	    $scale = $draw->GetScaleInfo();
	} else {
	    $draw = $req->CreateImageHelper();
	    $draw->Create();
	    $file = $draw->Save();
	    $no_data = true;
	}
     break;
     default:
        if ($req->props['module']) {
	    try {
		ADEI::RequireServiceClass("update", $req->props['module']);
		$loaded = true;
	    } catch (ADEIException $ae) {
		// modules without updates are perfectly OK
		$loaded = false;
	    }
	    
	    if ($loaded) {		
		if (!function_exists("ADEIServiceGetUpdateInfo")) {
		    throw new ADEIException(translate("Update code for module (%s) does not provide any suitable interface"));
		}
		
		$info = ADEIServiceGetUpdateInfo($req);
	    }
	}
    }
} catch(ADEIException $e) {
    $error = $e->getInfo();

    if (($draw)&&(($e->getCode() == ADEIException::NO_DATA)||($e->getCode() == ADEIException::NO_CACHE))) {
/*	if (($e->getCode() == ADEIException::NO_CACHE)&&($req->IsVirtual())) {
	    $error = "----------------";
	}*/
	
	try {
	    $no_data = true;
	    $draw->CreateMessage("Error", $error);
	    $file = $draw->Save();
	    $error = false;
	} catch (ADEIException $ex) {
	    $no_data = false;
	    $ex->logInfo(NULL, $draw);
	}
    } else {
	$e->logInfo(NULL, $draw?$draw:$req);	
    }
}

if ($error) {
    echo json_encode(array("error" => $error));
} else {
    if ($draw) {
	if ($no_data) {
	    echo json_encode(array(
		"module" => "graph",
		"nodata" => true,
		"draw" => 1,
		"image" => $file
	    ));
	} else {
	    echo json_encode(array_merge(array(
		"error" => 0,
		"module" => "graph",
		"draw" => 1,
		"image" => $file
	    ), $scale));
	}
    } else if ($info) {
	if (!$info['module']) $info['module'] = $req->props['module'];
	echo json_encode($info);
    } else {
	echo json_encode(array(
	    "error" => 0
	));
    }
}


?>