<?php
$TITLE = "";
$MODULES = array("config", "graph", "wiki");


$EXPORT_FORMATS = array (
	"csv" => array(
	    'title' => "CSV",
	),
	"xls" => array(
	    'title' => "Excel",
	    'handler' => "EXCEL",
	),
	"tdms" => array(
	    'title' => "TDMS",
	    'handler' => "LABVIEW",
	    'type' => "tdms"
	)
);


$READER_DB_TOSKA = array(
	"toska" => array (
	    "title" => _("TOSKA"),
	    "reader" => "DBReader",
	    "driver" => "odbc",
	    "sqldrv" => "mssql",
	    "subdrv" => "FreeTDS",
	    "host" => "itpfmdb1.ka.fzk.de",
	    "port" => 1433,
	    "user" => "souren",
	    "password" => '$souren$',
	    "database" => array("womisaDB_repl"),
	    "charset" => "ISO8859-1",
//	    "disconnected" => true
	)
);

if (is_array($READER_DB)) $READER_DB = array_merge($READER_DB_TOSKA, $READER_DB);
else $READER_DB = $READER_DB_TOSKA;

$OPTIONS["toska__womisaDB_repl"] = array(
	    "groups" => array(
		"/^m(\d+)$/" => 'Wv$LiveData$Modul${1}',
		"/^mod_([\w\d_]+)$/" => 'Wv$LiveData$Modul_${1}',
		"/^src_([\w\d_]+)$/" => 'Wv$LiveData\$${1}',
		"/^sps(\d+)$/" => 'Wv$LiveData$SPSDB${1}',
//		"/^plc$/" => 'Wv$LiveData$Modul_PLC',
//		"/^modul(\d+)$/" => 'mda.Wt$LiveData$ModulTest${1}',
		"/^strom(\d+)$/" => 'Wv$Meda$STROMTEST_SE002$r${1}$ITPFMPXI01$Modul01\$09',
		"/^isoamp(\d+)$/" => 'Wv$Meda$IsoAmp$r${1}$ITPFMPXI02$Modul02\$06'
	    ),
	    "tables" => array(
/*		"/^.*ModulTest(\d+)$/" => array(
		"/^.*ModulTest(10)$/" => array(
		    'gid' => 'modul${1}',
		    'title' => 'Test ${1} Hz'
		),*/
		"/^Wv\\\$LiveData\\\$Modul(02|10|11)$/" => array(
		    'gid' => 'm${1}',
		    'title' => 'Module ${1}'
		),    
		"/^Wv\\\$LiveData\\\$SPSDB(131)$/" => array(
		    'gid' => 'sps${1}',
		    'title' => 'ITP-SPS-DB ${1}'
		),
		"/^Wv\\\$LiveData\\\$Modul_(\w+)$/" => array(
		    'gid' => 'mod_${1}',
		    'title' => 'Module ${1}'
		),
		"/^Wv.*STROMTEST.*r(012).*$/" => array(
		    'gid' => 'strom${1}',
		    'title' => 'StromTest ${1}'
		),
		"/^Wv.*IsoAmp.*r(001).*$/" => array(
		    'gid' => 'isoamp${1}',
		    'title' => 'ISO AMP ${1}'
		),
		"/^Wv\\\$LiveData\\\$([TE]_\w+)$/" => array(
		    'gid' => 'src_${1}',
		    'title' => '${1}'
		),
		"/^Wv\\\$LiveData\\\$(SC)(\d+)$/" => array(
		    'gid' => 'src_${1}${2}',
		    'title' => '${1} ${2}'
		),
		"/^Wv\\\$LiveData\\\$(SC)(\d+)_([\w\d_]+)$/" => array(
		    'gid' => 'src_${1}${2}_${3}',
		    'title' => '${1} ${2} ${3}'
		),
	    ),
	    "columns" => array(
		"time" => "WsDateTimeTicks",
		"data" => "/^((WsCh_\d+)|([^W.])|(.[^s]))/"
	    ),
	    "timezone" => "Europe/Berlin",
	    "time_module" => "MSTICKS",
//	    "time_options" => -36000000000,			// correction
	    "timesort" => 1,					// 0 - NATURAL, 1 - ASC, -1 - DESC, string whith request
	    "date_limit" => "2008-01-01 00:00:00",		//GMT
//	    "date_limit" => "2008-03-29 21:00:00",		//GMT
	    "min_resolution" => 10,
	    "ignore_subseconds" => false,
	    "optimize_empty_cache" => true,
	    "use_cache_timewindow" => true,
//	    "use_cache_reader" => true,
	    "use_md5_postfix" => true,
	    "trace_timings" => false,
	    "channel_uids" => true,
	    "monitor_timings" => array(
		"query_limit" => 500000,		/* us */
		"raise_exception" => true
	    )
);

$OPTIONS["toska__womisaDB_repl__m01"] = array(
    "date_limit" => "2008-04-09 10:00:00"		//GMT
);

$OPTIONS["toska__womisaDB_repl__mod_PLC"] = array(
    "date_limit" => "2008-06-11 09:00:00"
);

$OPTIONS["toska__womisaDB_repl__modul1000"] = array(
    "min_resolution" => 1,
    "cache_config" => array(
	array("min" => 31536000, "res" => 43200),
	array("min" => 2592000, "res" => 3600),
	array("min" => 604800, "res" => 600),
	array("min" => 86400, "res" => 60),
	array("min" => 7200, "res" => 10),
	array("min" => 600, "res" => 1)
    )
);

$OPTIONS["toska__womisaDB_repl__strom012"] = array(
    "min_resolution" => 1,
    "cache_config" => array(
	array("min" => 31536000, "res" => 43200),
	array("min" => 2592000, "res" => 3600),
	array("min" => 604800, "res" => 600),
	array("min" => 86400, "res" => 60),
	array("min" => 7200, "res" => 10),
	array("min" => 600, "res" => 1)
    )
);


// Enable in release
#    $SOURCE_KEEP_WINDOW = true;

?>