<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
 <xsl:output method="html" encoding="utf-8"/>

 <xsl:template match="/result/alarms/Value">
    <tr>
	<td><xsl:value-of select="@severity"/></td>
	<td><xsl:value-of select="@name"/></td>
	<td><xsl:value-of select="@in"/></td>
	<td><xsl:value-of select="@description"/></td>
    </tr>
 </xsl:template>

 <xsl:template match="alarms">
  <div>
    <xsl:if test="/result/@title">
	<h1>List of alarms for: <xsl:value-of select="/result/@title"/></h1>
    </xsl:if>

    <xsl:if test="not(//Error)">
      <table>
	<tr>
	    <th>Severity</th>
	    <th>Alarm</th>
	    <th>Arrived</th>
	    <th>Description</th>
	</tr>
	<xsl:apply-templates select="Value"/>
     </table>
    </xsl:if>
  </div>
 </xsl:template>


 <xsl:template match="/result/data/Value">
    <tr>
	<td>
	    <xsl:if test="@uid">
		<xsl:value-of select="@uid"/>
	    </xsl:if>
	    <xsl:if test="not(@uid)">
		<xsl:value-of select="@channel_id"/>
	    </xsl:if>
	</td>
	<td><xsl:value-of select="@value"/></td>
	<td><xsl:value-of select="@timestamp"/></td>
	<td><xsl:value-of select="@verified"/></td>
	<td><xsl:value-of select="@channel_name"/></td>
    </tr>
 </xsl:template>

 <xsl:template match="data">
  <div>
    <xsl:if test="/result/@title">
	<h1>Control Values for: <xsl:value-of select="/result/@title"/></h1>
    </xsl:if>
    
    <xsl:if test="not(//Error)">
      <table>
	<tr>
	    <th>Channel</th>
	    <th>Value</th>
	    <th>Timestamp</th>
	    <th>Verified</th>
	    <th>Description</th>
	</tr>
	<xsl:apply-templates select="Value"/>
     </table>
    </xsl:if>
  </div>
 </xsl:template>

 <xsl:template match="/result">
  <div>
    <xsl:if test="//Error">
	<span class="error"><xsl:value-of select="//Error"/></span>
    </xsl:if>

    <xsl:apply-templates select="data|alarms"/>
  </div>
 </xsl:template>

</xsl:stylesheet>
